<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\DashboardService;
use FM\Traits\TResponse;

class DashboardController
{

    use TResponse;
    protected $DashboardService;

    public function __construct(DashboardService $DashboardService)
    {
        $this->DashboardService = $DashboardService;
    }

    public function dataBaseChartPie()
    {
        try {
            $data = $this->DashboardService->dataBaseChartPie();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseChartBar()
    {
        try {
            $data = $this->DashboardService->dataBaseChartBar();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function tarefasFinalizadas()
    {
        try {
            $data = $this->DashboardService->tarefasFinalizadas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function tarefasAtrasadas()
    {
        try {
            $data = $this->DashboardService->tarefasAtrasadas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function tarefasConcluidas()
    {
        try {
            $data = $this->DashboardService->tarefasConcluidas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function ultimasTarefasRealizadas()
    {
        try {
            $data = $this->DashboardService->ultimasTarefasRealizadas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
