<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EquipamentoService;
use FM\Traits\TResponse;

class EquipamentoController {
    use TResponse;
    protected $EquipamentoService;
   
    public function __construct(EquipamentoService $EquipamentoService) {
        $this->EquipamentoService = $EquipamentoService;
    }
    
    public function dadosAtivos(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('ativos', $this->EquipamentoService->dadosAtivos()));
    }
    
    public function ativo(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        if ($method== "POST") {
            $response->addDataSet(new DataSet('resultado', [$this->EquipamentoService->insertAtivo( $request->getParameters())]));
        } elseif ($method == "GET") {
            $response->addDataSet(new DataSet('detalheAtivo', $this->EquipamentoService->ativo( $request->getParameters()['NR'])));
        }
    }
    
    public function insumosDeManutencao(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('listaInsumos', $this->EquipamentoService->insumosDeManutencao( $request->getParameters()['NR'])));
    }
    
    public function atualizarAtivo(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('resultado', [$this->EquipamentoService->atualizarAtivo( $request->getParameters())]));
    }
    
    public function getEquipamento(Request $request)
    {
        try {
            $data = $this->EquipamentoService->getEquipamento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
