<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\Fm00002VistoriasService;
use FM\Traits\TResponse;

class Fm00002VistoriasController
{
    use TResponse;

    protected $VistoriasService;

    public function __construct($VistoriasService)
    {
        $this->VistoriasService = $VistoriasService;
    }

    public function getVistoriasListadas(Request $request)
    {
        try {
            $data = $this->VistoriasService->getVistoriasListadas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosVistorias(Request $request)
    {
        try {
            $data = $this->VistoriasService->getFotosVistorias($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirFotoVistorias(Request $request)
    {
        try {
            $data = $this->VistoriasService->excluirFotoVistorias($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAtividades(Request $request)
    {
        try {
            $data = $this->VistoriasService->getAtividades($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function anexarImagensVistoria(Request $request)
    {
        try {
            $data = $this->VistoriasService->anexarImagensVistoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriterios(Request $request)
    {
        try {
            //debugApi(['cheguei nos criterios']);
            $data = $this->VistoriasService->getCriterios($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarCriterios(Request $request)
    {
        try {
            $data = $this->VistoriasService->salvarCriterios($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function finalizarVistoria(Request $request)
    {
        try {
            $data = $this->VistoriasService->finalizarVistoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
