<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncionarioService;

class FuncionarioController
{
    protected $FuncionarioService;

    public function __construct(FuncionarioService $FuncionarioService)
    {
        $this->FuncionarioService = $FuncionarioService;
    }

    public function getEmployee(DTO\Request $request, DTO\Response $response)
    {
        $params = $request->getParameters();
        $var = $this->FuncionarioService->getEmployee($params);
        $dtsVal = new DataSet("employee", $var);
        $response->addDataSet($dtsVal);
    }

    public function joinPerfilAcesso(DTO\Request $request, DTO\Response $response)
    {
        $params = $request->getParameters();
        $funcs = $this->FuncionarioService->joinPerfilAcesso($params);
        $dtsVal = new DataSet("Funcionarios", $funcs);
        $response->addDataSet($dtsVal);
    }
}
