<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class OrdemServFactory {
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getOrdemServ($NR) {
        $alter="ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";
        $std = $this->connection->prepare($alter);
        $std->execute();

        $sql = "SELECT FCM_ORDEMSERV.NRORDEMSERV, TO_CHAR(FCM_ORDEMSERV.DTORDEMSERV, 'DD/MM/YYYY') AS DTORDEMSERV, FCM_TIPOMANUTENCAO.NMTIPOMANUTENCAO,
                       FCM_CATEGORIAMANUT.NMCATEGORIAMANUT,
                       CASE WHEN FCM_FUNCIONARIO.NMFUNCIONARIO IS NULL THEN ' ' ELSE FCM_FUNCIONARIO.NMFUNCIONARIO END AS NMFUNCIONARIO,
                       CASE FCM_ORDEMSERV.IDSITUACAO WHEN '1' THEN 'Pendente'
                                                        WHEN '2' THEN 'Em Andamento'
                                                     WHEN '3' THEN 'Concluída' END AS IDSITUACAO
                FROM FCM_ORDEMSERV
                JOIN FCM_CATEGORIAMANUT
                  ON FCM_ORDEMSERV.NRCATEGORIAMANUT = FCM_CATEGORIAMANUT.NRCATEGORIAMANUT
           left JOIN FCM_RESPONSAVEISORDEMSERV
                  ON FCM_ORDEMSERV.NRORDEMSERV = FCM_RESPONSAVEISORDEMSERV.NRORDEMSERV
           left JOIN FCM_FUNCIONARIO
                  ON FCM_RESPONSAVEISORDEMSERV.NRFUNCIONARIO = FCM_FUNCIONARIO.NRFUNCIONARIO
                JOIN FCM_TIPOMANUTENCAO
                  ON FCM_ORDEMSERV.NRTIPOMANUTENCAO = FCM_TIPOMANUTENCAO.NRTIPOMANUTENCAO
               WHERE FCM_ORDEMSERV.NREQUIPAMENTO = ".$NR;

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getOrdensServicoParaDashboard() {

      $sql = "SELECT OS.NRORDEMSERV, TO_CHAR(OS.DTORDEMSERV, 'DD/MM/YY') DTORDEMSERV, CAT.NMCATEGORIAMANUT,
                CASE OS.IDSITUACAO WHEN '1' THEN 'ABERTA'
                  WHEN '2' THEN 'EM ANDAMENTO'
                  WHEN '3' THEN  'FECHADA'
                  ELSE NULL END AS IDSITUACAO
                FROM FCM_ORDEMSERV OS
                JOIN FCM_CATEGORIAMANUT CAT
                  ON CAT.NRCATEGORIAMANUT = OS.NRCATEGORIAMANUT";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }

    public function getOrdensServicoDash()
    {
        $sql = "SELECT OS.NRORDEMSERV, TO_CHAR(OS.DTORDEMSERV, 'DD/MM/YY') DTORDEMSERV, CAT.NMCATEGORIAMANUT,
                CASE OS.IDSITUACAO WHEN '1' THEN 'ABERTA'
                  WHEN '2' THEN 'EM ANDAMENTO'
                  WHEN '3' THEN  'FECHADA'
                  ELSE NULL END AS IDSITUACAO
                FROM FCM_ORDEMSERV OS
                JOIN FCM_CATEGORIAMANUT CAT
                ON CAT.NRCATEGORIAMANUT = OS.NRCATEGORIAMANUT
                ORDER BY OS.NRORDEMSERV DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getOrdensPendentes() {

      $sql = "SELECT R.NRRELSOLICITAORDEMSERV, R.NRSOLICITACAOSERV, R.NRORDEMSERV, TO_CHAR(O.DTORDEMSERV) DTORDEMSERV, CAT.NMCATEGORIAMANUT, S.IDSITUACAO,
                CASE O.IDSITUACAO WHEN '1' THEN 'PENDENTE'
                WHEN '2' THEN 'EM ANDAMENTO'
                WHEN '3' THEN 'CONCLUÍDA'
                ELSE NULL END AS IDSITUACAOORDEM
            FROM FCM_RELSOLICITAORDEMSERV R
            JOIN FCM_ORDEMSERV O
              ON O.NRORDEMSERV = R.NRORDEMSERV
            JOIN FCM_SOLICITACAOSERV S
              ON S.NRSOLICITACAOSERV = R.NRSOLICITACAOSERV
            JOIN FCM_CATEGORIAMANUT CAT
              ON CAT.NRCATEGORIAMANUT = S.NRCATEGORIAMANUT
            WHERE S.IDSITUACAO = '3'";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
}

?>