CREATE OR REPLACE FORCE VIEW DM_DTPROCESSA(CDFILIAL, NMFILIAL, CDSEGMER, CDGOPERAC, CDREGIAO, CDAREAGERE,
                                           CDPLANEJADORA, CDGUNIDADE, CDSUPERVISOR, DTPROCESSA, DSDTPROCESSA, QTDIASATRASOPROC)
AS
   SELECT CDFILIAL, NMFILIAL, CDSEGMER, CDGOPERAC, CDREGIAO, CDAREAGERE,
           CDPLANEJADORA, CDGUNIDADE, CDSUPERVISOR, DTPROCESSA, TO_CHAR(DTPROCESSA, 'DD/MM/YYYY') AS DSDTPROCESSA, COUNT(*) AS QTDIASATRASOPROC
    FROM
       (SELECT PF.CDFILIAL, F.NMFILIAL, CDSEGMER, CDGOPERAC, CDREGIAO, CDAREAGERE,
               CDPLANEJADORA, CDGUNIDADE, CDSUPERVISOR, PF.DTPROCESSA, DT.DTDATA
        FROM PARAMFILIAL PF,
             DATA DT,
             FILIAL F
        WHERE DT.DTDATA BETWEEN PF.DTPROCESSA AND SYSDATE AND
              PF.DTPROCESSA IS NOT NULL AND
              PF.CDFILIAL = F.CDFILIAL AND
              F.IDCNTRRESC = 'N' AND
              NOT EXISTS (SELECT 1
                          FROM FERIFILI FF
                          WHERE FF.CDFILIAL = PF.CDFILIAL AND
                                FF.DTFERIFILI = DT.DTDATA)
        ORDER BY
           PF.CDFILIAL,
           DT.DTDATA
       )
   GROUP BY CDFILIAL, NMFILIAL, CDSEGMER, CDGOPERAC, CDREGIAO, CDAREAGERE,
           CDPLANEJADORA, CDGUNIDADE, CDSUPERVISOR, DTPROCESSA, TO_CHAR(DTPROCESSA, 'DD/MM/YYYY') ;
/

DECLARE V_IDIOMA VARCHAR2 (03) NULL;

BEGIN
   SELECT NVL(DSINSTALLANGUAGE, 'POR')
   INTO V_IDIOMA
   FROM PARAMGERAL;

   IF (V_IDIOMA = 'POR' OR V_IDIOMA = 'ING') THEN
      CRIA_FATOS('DM_DTPROCESSA', 'QTDIASATRASOPROC', 'Dias Atraso', 'Dias Atraso Ref. data Proc.', 'Data de Processamento');
      CRIA_DIME('DM_DTPROCESSA', 'CDFILIAL', 'Filial', 'FILIAL', 'CDFILIAL', 'NMFILIAL', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'DSDTPROCESSA', 'Data Proc.', NULL, NULL, NULL, NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDSEGMER', 'Seg.Mercado', 'SEGMERCADO', 'CDSEGMER', 'DSSEGMER', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDGOPERAC', 'GO', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDREGIAO', 'Regiao', 'REGIAO', 'CDREGIAO', 'NMREGIAO', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDAREAGERE', 'Regional', 'AREAGERE', 'CDAREAGERE', 'NMAREAGERE', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDPLANEJADORA', 'Planejadora', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDGUNIDADE', 'GU', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
      CRIA_DIME('DM_DTPROCESSA', 'CDSUPERVISOR', 'Planejadora', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
   ELSE
      CRIA_FATOS('DM_DTPROCESSA', 'QTDIASATRASOPROC', 'Das de Atraso', 'Das de Atraso Referente a Fecha de Procesamiento', 'Fecha de Procesamiento');
      CRIA_DIME('DM_DTPROCESSA',  'CDFILIAL', 'Site', 'FILIAL', 'CDFILIAL', 'NMFILIAL', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'DSDTPROCESSA', 'Fecha Procesamiento', NULL, NULL, NULL, NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDSEGMER', 'Seg.Mercado', 'SEGMERCADO', 'CDSEGMER', 'DSSEGMER', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDGOPERAC', 'GO', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDREGIAO', 'Regiao', 'REGIAO', 'CDREGIAO', 'NMREGIAO', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDAREAGERE', 'Regional', 'AREAGERE', 'CDAREAGERE', 'NMAREAGERE', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDPLANEJADORA', 'Planejadora', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDGUNIDADE', 'GU', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
      CRIA_DIME('DM_DTPROCESSA',  'CDSUPERVISOR', 'Planejadora', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL);
   END IF;
END;
/

--VERSO--
BEGIN ATUVEROBJ('DM_DTPROCESSA','5.75.000'); END;
/
