IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_GESHOSPITALAR' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_GESHOSPITALAR
GO
CREATE PROCEDURE APURAC_GESHOSPITALAR
(
   @P_CDFILIAL    VARCHAR(04),
   @P_CDFILIPROC  VARCHAR(04),
   @P_CDCLIENTE   VARCHAR(21),
   @P_DATAINI     DATETIME,
   @P_DATAFIM     DATETIME,
   @P_NRAPURACFAT VARCHAR(10),
   @P_IDGERANOTA  VARCHAR(01) = 'S')
AS

   DECLARE @V_NRLANCTONF      VARCHAR(20);
   DECLARE @V_NRLANCESTQ      VARCHAR(10);
   DECLARE @V_VRPRATFATU      FLOAT;
   DECLARE @V_VRBRUTITEM      FLOAT;
   DECLARE @V_CDDIETPAD       VARCHAR(04);
   DECLARE @V_VRDIETFATU      FLOAT;
   DECLARE @V_CDSERVFILI      VARCHAR(05);
   DECLARE @V_DSDIETPAD       VARCHAR(50);
   DECLARE @V_CDEMPRESA       VARCHAR(2);
   DECLARE @V_CDINSCMUNI      VARCHAR(16);
   DECLARE @V_CDINSCESTA      VARCHAR(16);
   DECLARE @V_CDSERIE         VARCHAR(05);
   DECLARE @V_TTITENSNF       FLOAT;
   DECLARE @V_PRIM            VARCHAR(01);
   DECLARE @V_PRODUTO         VARCHAR(10);
   DECLARE @V_CONTITEM        FLOAT;
   DECLARE @V_CDFILIALDEL     VARCHAR(04);
   DECLARE @V_NRLANCTODEL     VARCHAR(10);
   DECLARE @V_CONTADOR        VARCHAR(17);
   DECLARE @V_CDFILIALCEFE    VARCHAR(04);
   DECLARE @V_CDSERVFILICEFE  VARCHAR(05);
   DECLARE @V_CDCLIENTECEFE   VARCHAR(21);
   DECLARE @V_CDDIETPADCEFE   VARCHAR(04);
   DECLARE @V_NMSERVICOCEFE   VARCHAR(40);
   DECLARE @V_QTCOMEFETDIE    FLOAT;
   DECLARE @V_IDUTEFETPAH     VARCHAR(01); /*IDENTIFICADOR SE UTILIZA EFETIVO DO PAH ('S') OU DO FAI ('N')*/
   DECLARE @V_FECHANOTA       VARCHAR(01); /*IDENTIFICADOR PARA VERIFICAR SE SER NECESSRIO FECHAR A NOTA*/ 
   DECLARE @V_DESCEMISS       VARCHAR(90);

BEGIN
   SET @V_PRIM = 'S';
   SET @V_FECHANOTA = 'N';

   SELECT @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCMUNI = MAX(CDINSCMUNI), @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDSERIE = MAX(CDSERIE)
   FROM FILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   SELECT @V_TTITENSNF = ISNULL(MAX(NRMAXITNF),10)
   FROM SERIENF
   WHERE CDEMPRESA  = @V_CDEMPRESA  AND
         CDINSCESTA = @V_CDINSCESTA AND
         CDSERIE    = @V_CDSERIE;

   SET @V_CONTITEM = 0;

   DECLARE CURS_NF CURSOR FOR
   SELECT CDFILIAL, NRLANCTONF
   FROM NOTAFISCAL
   WHERE (CDFILIAL    = @P_CDFILIPROC) AND
         (NRAPURACFAT = @P_NRAPURACFAT);
   OPEN CURS_NF;
   FETCH NEXT FROM CURS_NF INTO @V_CDFILIALDEL, @V_NRLANCTODEL;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXEC DELETA_NF @V_CDFILIALDEL, @V_NRLANCTODEL;
      FETCH NEXT FROM CURS_NF INTO @V_CDFILIALDEL, @V_NRLANCTODEL;
   END;
   CLOSE CURS_NF;
   DEALLOCATE CURS_NF;

   /*VERIFICA DE QUAL TABELA SERO SELECIONADOS OS EFETIVOS - 'S' DA EFETDIET E 'N' DA EFECLIFATPAH*/
   SELECT @V_IDUTEFETPAH = IDUTEFETPAH
     FROM PARAMGERAL;

   IF (@V_IDUTEFETPAH = 'N') BEGIN  /*UTILIZA EFETIVOS LANADOS NO FAI*/
      DECLARE C_CALCEFETI CURSOR FOR
         SELECT E.CDFILIAL, E.CDSERVFILI, E.CDCLIENTE,
                E.CDDIETPAD, S.NMSERVICO,
                SUM(E.QTCOMEFATPAH) AS QTEFETIVOS
           FROM EFECLIFATPAH E, SERVICO S            
          WHERE E.CDFILIAL    = @P_CDFILIAL   AND
                E.CDCLIENTE   = @P_CDCLIENTE  AND
                E.DTEFETFATPAH BETWEEN @P_DATAINI AND @P_DATAFIM AND
                E.CDFILIAL    = S.CDFILIAL   AND
                E.CDSERVFILI  = S.CDSERVFILI
       GROUP BY E.CDFILIAL, E.CDSERVFILI, E.CDCLIENTE,
                E.CDDIETPAD, S.NMSERVICO
       ORDER BY E.CDSERVFILI, E.CDDIETPAD;
   END;  
   IF (@V_IDUTEFETPAH = 'S') BEGIN  /*UTILIZA EFETIVOS LANADOS NO PAH*/
      DECLARE C_CALCEFETI CURSOR FOR
         SELECT E.CDFILIAL, E.CDSERVFILI, E.CDCLIENTE,
                E.CDDIETPAD, S.NMSERVICO,
                SUM(E.QTCOMEFETDIE) AS QTEFETIVOS
           FROM EFETDIET E, SERVICO S
          WHERE E.CDFILIAL    = @P_CDFILIAL   AND
                E.CDCLIENTE   = @P_CDCLIENTE  AND
                E.DTEFETDIET BETWEEN @P_DATAINI AND @P_DATAFIM AND
                E.CDFILIAL    = S.CDFILIAL   AND
                E.CDSERVFILI  = S.CDSERVFILI
       GROUP BY E.CDFILIAL, E.CDSERVFILI, E.CDCLIENTE,
                E.CDDIETPAD, S.NMSERVICO
       ORDER BY E.CDSERVFILI, E.CDDIETPAD;
   END;

   OPEN C_CALCEFETI;
   FETCH NEXT FROM C_CALCEFETI INTO @V_CDFILIALCEFE , @V_CDSERVFILICEFE, @V_CDCLIENTECEFE,
                                    @V_CDDIETPADCEFE, @V_NMSERVICOCEFE , @V_QTCOMEFETDIE;

   WHILE (@@FETCH_STATUS = 0)  BEGIN
      /*Verifica se existem efetivs para gerar a nota*/
      IF @V_QTCOMEFETDIE > 0 BEGIN
         /*se existir efetivs verifica se a dieta tem preco*/        
         SELECT  @V_CDDIETPAD  = MAX(SC.CDDIETPAD), @V_VRDIETFATU = MAX(SC.VRSERVFATUPAH),
                 @V_CDSERVFILI = MAX(SC.CDSERVFILI), @V_DSDIETPAD = MAX(DP.DSDIETPAD)
         FROM SERVCLIEPAH SC, DIETPADR DP
         WHERE (SC.CDFILIAL   = @P_CDFILIAL)             AND
               (SC.CDSERVFILI = @V_CDSERVFILICEFE) AND
               (SC.CDCLIENTE = @V_CDCLIENTECEFE) AND
               (SC.CDDIETPAD  = @V_CDDIETPADCEFE)  AND
               (SC.CDDIETPAD  = DP.CDDIETPAD);
         SET @V_VRBRUTITEM = @V_VRDIETFATU;

         IF @V_VRBRUTITEM IS NOT NULL BEGIN
         /* verifica se a dieta tem preo*/
            IF @V_PRIM = 'S' BEGIN
            /*se for o primeiro registro ou se for lanar uma nova nota*/   
               SET @V_CONTADOR = 'LANCNF/FILIAL' + @P_CDFILIPROC;
               EXEC NOVO_CODIGO @V_CONTADOR, @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT, @P_QTDE = 1;

               SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);


               EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @P_CDFILIAL, @V_CDEMPRESA, '01',
                                          @V_CDSERIE, @P_CDCLIENTE, @P_DATAFIM, 'FAI', 'N',
                                          @P_NRAPURACFAT, @V_NRLANCTONF, NULL, NULL, NULL, 
                                          NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
                                          NULL, NULL, NULL, NULL, NULL, 
                                          @P_PRXLANCTONF = @V_NRLANCTONF OUTPUT, 
                                          @P_PRXLANCESTQ = @V_NRLANCESTQ OUTPUT;

               SET @V_PRIM  = 'N';
               SET @V_FECHANOTA = 'S';/*RECEBE 'S' PARA FECHAR A NOTA NO FIM DA ROTINA*/
            END;

            SELECT @V_PRODUTO = MAX(CDPRODUTO)
              FROM  SERVICO
             WHERE CDSERVFILI = @V_CDSERVFILICEFE
               AND CDFILIAL   = @P_CDFILIAL;
            
            /*PREPARA A DESCRIO DE EMISSAO DA NOTA (DESCRIO DA DIETA + NOME DO SERVIO)*/
            SET @V_DESCEMISS = @V_DSDIETPAD + ' - ' + @V_NMSERVICOCEFE;   
            EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_PRODUTO,
                                         @V_CDSERVFILI, @V_DESCEMISS,
                                         @V_QTCOMEFETDIE, @V_VRBRUTITEM;
 
            SET @V_CONTITEM = @V_CONTITEM + 1;

            IF (@V_CONTITEM = @V_TTITENSNF) BEGIN
               EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
               SET @V_PRIM  = 'S';
               SET @V_FECHANOTA = 'N'; /*RECEBE 'N' PORQUE A NOTA J FOI FECHADA*/
            END;
         END;
      END;   
      FETCH NEXT FROM C_CALCEFETI INTO @V_CDFILIALCEFE , @V_CDSERVFILICEFE, @V_CDCLIENTECEFE,
                                       @V_CDDIETPADCEFE, @V_NMSERVICOCEFE , @V_QTCOMEFETDIE;
   END;
   CLOSE C_CALCEFETI;
   DEALLOCATE C_CALCEFETI;

   IF (@V_FECHANOTA = 'S') BEGIN
      EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
   END;   
   /*ATUALIZA OS CAMPOS NRAPURACFAT E CDFILIFATU DA TABELA DE EFETIVOS UTILIZADA PARA CONTROLE*/
   IF (@V_IDUTEFETPAH = 'S') BEGIN  /*ATUALIZA A TABELA UTILIZADA PELO PAH*/
      UPDATE EFETDIET
         SET CDFILIFATU = @P_CDFILIPROC,
             NRAPURACFAT = @P_NRAPURACFAT
       WHERE CDFILIAL    = @P_CDFILIAL   AND
             CDCLIENTE   = @P_CDCLIENTE  AND
             DTEFETDIET BETWEEN @P_DATAINI AND @P_DATAFIM;
   END;
   IF (@V_IDUTEFETPAH = 'N') BEGIN /*ATUALIZA A TABELA UTILIZADA PELO FAI*/
      UPDATE EFECLIFATPAH
         SET CDFILIFATU = @P_CDFILIPROC,
             NRAPURACFAT = @P_NRAPURACFAT
       WHERE CDFILIAL    = @P_CDFILIAL   AND
             CDCLIENTE   = @P_CDCLIENTE  AND
             DTEFETFATPAH BETWEEN @P_DATAINI AND @P_DATAFIM;
   END;           
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APURAC_GESHOSPITALAR','6.35.019';
GO
